<?php
/*
Plugin Name: Plugin Ejemplo Generación de Menús en WP
Plugin URI: http://blog.ikhuerta.com
Description: Ejemplo de Plugin que genera menús en el adminsitrador de wordpress. Código comentado inline para que se entienda. Este plugin generará una nueva opción en el menú de entradas y un nuevo bloque de memús en la columna de menú del admin.
Version: 1.0
Author: ikhuerta (iñaki Huerta)
Author URI: http://blog.ikhuerta.com
*/

////////////////

///////////////////////////////////////////////////////////
// PRIMERA PARTE : AÑADIR NUESTRO PROPIO BLOQUE DE MENÚS //
///////////////////////////////////////////////////////////

add_action('admin_menu', 'function_menu'); 
function function_menu()
{
	// Extraemos el directorio en el que estamos para ir usándolo luego
	$pluginDir = pathinfo( __FILE__ );
	$pluginDir = $pluginDir['dirname'];
	
	
	//////// DECLARACION DEL MENU ////////////
	
	// titulo de la nueva sección:
	$page_title = "Mi nueva Sección";
	
	// titulo en el menú
	$menu_title = "Mi Menú";
	
	// nivel necesario para poder ver el menú (admin:10, editores:8)
	// + info en: http://codex.wordpress.org/User_Levels
	$access_level = "8";
	
	// la página que se cargará al clickar en el menú
	$content_file = $pluginDir . '/mimenu/index.php';

	// Función para cargar dentro de la página incluida para generar el menú
	// Si no se indica, se asume que al incluir el fichero ya se ha generado todo el
	// contenido necesario.
	$content_function = null;
	
	// url del icono para el menú
	$menu_icon_url = null;
	
	add_menu_page($page_title, $menu_title, $access_level, $content_file, $content_function, $menu_icon_url); 
		// Declaramos también como primer submenú la misma página con los mismos datos
		add_submenu_page($content_file,$page_title, $menu_title, $access_level, $content_file, $content_function); 
	
	
	
	//////// DECLARACION DE CADA SUBMENU ////////////
	
	// La funcón para declarar submenús es igual que la anterior
	// pero se añade como primer parámetro el nombre usado como
	// $content_file en la página padre
	// Además, ya no se informa nunca el icon file.
	
	$page_parent = $pluginDir . '/mimenu/index.php'; 	// $content_file del padre
	$page_title = "Subseccion 1";						// Titulo de la página
	$menu_title = "Subsección 1";						// Título que aparece en el menú
	$access_level = "8";								// Nivel de acceso
	$content_file = $pluginDir . '/mimenu/subseccion1.php'; // página de destino
	$content_function = null;							// función a lanzar en la página de destino
	add_submenu_page($page_parent, $page_title, $menu_title, $access_level, $content_file, $content_function); 
}
////////////////



///////////////////////////////////////////////////
// SEGUNDA PARTE : AÑADIR OPCIONES A OTROS MENÚS //
///////////////////////////////////////////////////


// Usando add_submenu_page vamos a añadir nuevas opciones al menú de entradas principal

add_action('admin_menu', 'function_menu2'); 
function function_menu2()
{
	// Extraemos el directorio en el que estamos para ir usándolo luego
	$pluginDir = pathinfo( __FILE__ );
	$pluginDir = $pluginDir['dirname'];
	
	
	// Aqui lo que hacemos es indicar como página padrea la página del menú
	// donde añadimos las opciones.
	// En este caso "edit.php" es la página que se carga al dar al menú "Entradas"
	$page_parent = 'edit.php'; 	
	
	// Titulo de la página
	$page_title = "Nueva Opción";
	
	// Título que aparece en el menú					
	$menu_title = "Nueva Opción";

	// Nivel de acceso
	$access_level = "1";

	// página de destino
	$content_file = $pluginDir . '/nuevas_opciones_menu_entradas/minuevaopcion.php'; 
	
	// función a lanzar en la página de destino
	$content_function = null;							
	add_submenu_page($page_parent, $page_title, $menu_title, $access_level, $content_file, $content_function); 
	
}


add_action('admin_menu', 'function_menu3'); 
function function_menu3()
{
	// Extraemos el directorio en el que estamos para ir usándolo luego
	$pluginDir = pathinfo( __FILE__ );
	$pluginDir = $pluginDir['dirname'];
	
	// Titulo de la página
	$page_title = "Menú Integrado";
	
	// Título que aparece en el menú					
	$menu_title = "Menú Integrado";

	// Nivel de acceso
	$access_level = "1";

	// página de destino
	$content_file = $pluginDir . '/menu_integrado/index.php'; 
	
	// Función para cargar dentro de la página incluida para generar el menú
	// Si no se indica, se asume que al incluir el fichero ya se ha generado todo el
	// contenido necesario.
	$content_function = null;
	
	// url del icono para el menú
	$menu_icon_url = null;
	
	add_object_page($page_title, $menu_title, $access_level, $content_file,$content_function,$menu_icon_url);
		// Declaramos también como primer submenú la misma página con los mismos datos
		add_submenu_page($content_file,$page_title, $menu_title, $access_level, $content_file, $content_function); 
		
	
	//////// DECLARACION DE CADA SUBMENU ////////////
	// La funcón para declarar submenús es igual que la anterior
	// pero se añade como primer parámetro el nombre usado como
	// $content_file en la página padre
	// Además, ya no se informa nunca el icon file.
	
	$page_parent = $pluginDir . '/menu_integrado/index.php';// $content_file del padre
	$page_title = "Subseccion 1";							// Titulo de la página
	$menu_title = "Subsección 1";							// Título que aparece en el menú
	$access_level = "0";									// Nivel de acceso
	$content_file = $pluginDir . '/menu_integrado/subseccion1.php'; // página de destino
	$content_function = null;								// función a lanzar en la página de destino
	add_submenu_page($page_parent, $page_title, $menu_title, $access_level, $content_file, $content_function); 
}
?>